#set page(width: auto, height: auto, margin: (top: -2em, bottom: 0em, left: 0em, right: 0em))

#import "@preview/cetz:0.2.2" 

#let fillc = gray.lighten(90%)

#let subsound = [
	#image("sub_sound.svg", width: 20em)
]

#let normalbox = (x) => {
	box([
		#set align(center)
		#x
	], stroke: 1pt + gray, fill: fillc, inset: 1em, )
}

#let importantbox = (x) => {
	box([
		#set align(center)
		#x
	], stroke: 2pt + red, fill: fillc, inset: 1em, )
}

#cetz.canvas({
	
	import cetz.draw: *; 
	set-style(content: (padding: .2),
	  fill: fillc,
	  stroke: gray
	)

	content((-0.5,2), subsound, angle: -60deg, name: sub, anchor: "west")


	line((-2, -0.4), (-2, -4.4), name: "collect")

	for value in (0, 1, 2) {
		circle((0, -value), radius: 0.2, name: "c")
		line("c.south", (rel: (0, -0.2)), name: "l")
	        line("l.end", (rel: (-2, 0)), stroke: (dash: "dashed", paint: gray))
	}
	content((0, -3), [$dots.v$])
	circle((0, -4), radius: 0.2, name: "c")
	line("c.south", (rel: (0, -0.2)), name: "l", )
	line("l.end", (rel: (-2, 0)), stroke: (dash: "dashed", paint: gray), name: "collect")

	line("collect.end", (rel: (0, -2)), name: "collect")
	
	// Helper circle to find the midpoint in the figure
	hide(circle("collect.end", name: "left", radius: 0.1))

        set-style(mark: (end: ">"))
	line("collect.end", (rel: (1, 0)), name: "collect")

	content("collect.end", [#normalbox([Data Acq. \ & Downsampling])], anchor: "west", name: "dads")
	line("dads.east", (rel: (1, 0)), name: "collect")
	content("collect.end", [#importantbox([Preprocessing])], anchor: "west", name: "prepro")
	line("prepro.east", (rel: (1, 0)), name: "collect")
	content("collect.end", [#normalbox([Tracking])], anchor: "west", name: "tracking")
	

        set-style(mark: (end: none))
	line(("tracking.south", 3, "tracking.north"), (rel: (-1, 0)), name: "motion")	
	line(("tracking.south", 4.5, "tracking.north"), (rel: (-1, 0)), name: "likline")	

        set-style(mark: (end: ">"))
	line("likline.start", "tracking.north")

	content("likline.end", [#importantbox([Likelihood])], anchor: "east", name: "prepro")
	content("motion.end", [#normalbox([Motion Model])], anchor: "east", name: "prepro")
	
	// Helper circle to find the midpoint in the figure
	hide(circle("tracking.east", radius: 0.1, name: "right"))


	hide(line("right", ("right.center", 50%, "left.center"), name: "mid1"))

        set-style(mark: (end: none))
	line("tracking.south", (rel: (0, -0.5)), name: "collect")
	
	intersections("i", {
		hide(line("mid1.end", (rel: (0, -5)), name: "mid2"))
		hide(line("collect.end", (rel: (-10, 0))))
	})
		
	line("collect.end", "i.0", name: "collect")
        set-style(mark: (end: ">"))
	line("collect.end", (rel: (0, -0.5)), name: "collect")
	
	hide(rect("left", "collect.end", name: "leftr"))
	hide(rect("collect.end", "tracking.south", name: "rightr"))
	hide(line("rightr.south-east", (rel: (0, -3)), name: "bheight"))
	
   	rect("leftr.south-west", "bheight.end", name: "plotbox", fill: gray.lighten(90%))
	
	set-style(stroke: black)
	line("plotbox.south-west", "plotbox.north-west", name: "yax")
	content("yax.mid", [Bearings [deg]], angle: 90deg, anchor: "south")
	line("plotbox.south-west", "plotbox.south-east", name: "xax")
	content("xax.mid", [Time [s]], anchor: "north")

	content("plotbox.north", [
		Track estimates
		], anchor: "north")
	
	content((1.5,-3.5), [
		*Far Field*], angle: -70deg)
	
	set-style(fill: none, mark: (end: "o"))
	
	translate(x: -0.5, y: -9.5)
   	bezier((0,0), (3,0), (1,-1), (2,1), stroke: blue)
	translate(x: -0.5, y: -0.5)
	hobby((2, 0), (4, -0.5), (5, 0.4), (8, -0.5), (9, 0), (10, -0.2), omega: 0, stroke: orange)

})

/*
#cetz.canvas({
  import cetz.draw: *

  set-style(content: (padding: .2),
    fill: gray.lighten(70%),
    stroke: gray
  )

	
  

  content((10,10), subsound, angle: -60deg, name: sub)
  
  

  
  set-style(mark: (end: ">"))

   
  group(name: "tracking_input", {
	  anchor("south", (0,0))
	  content((0,0), [#box([Measurement Model], stroke: (paint: red, dash: "dashed", thickness: 2pt), fill: gray.lighten(90%), inset: 1em, )], anchor: "north", name: "meas_model")
	  anchor("middle", "meas_model.south-east")
	  content("meas_model.south", [#box([Motion Model], stroke: 1pt + gray, fill: gray.lighten(90%), inset: 1em, )], anchor: "north", name: "DD")
  })

  content("tracking_input.middle", [#box([Tracking], stroke: 1pt + gray, fill: gray.lighten(90%), inset: 1em, )], anchor: "west", name: "tracking")

  line("tracking_input.south", (rel: (1, 0)), name: "arrow1")
  content("arrow1.end", [#box([Data acquisition  \ & downsampling], stroke: 1pt + gray, fill: gray.lighten(90%), inset: 1em, )], anchor: "west", name: "DD")
  
  line("DD.east", (rel: (1,0)), name: "arrow2")
  content("arrow2.end", [#box([Preprocessing], stroke: (paint: red, dash: "dashed", thickness: 2pt), fill: gray.lighten(90%), inset: 1em, )], anchor: "west", name: "test")

})
*/
